/*
 * IIIMF-SKK, Japanese Language Engine for 
 *                        IIIMF (Internet/Intranet Input Method Framework)
 * 
 * Copyright (C) 2002 Motonobu Ichimura <famao@kondara.org>
 *
 * All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright notice(s) and this permission notice appear in all copies of
 * the Software and that both the above copyright notice(s) and this
 * permission notice appear in supporting documentation.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
 * INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Except as contained in this notice, the name of a copyright holder
 * shall not be used in advertising or otherwise to promote the sale, use
 * or other dealings in this Software without prior written authorization
 * of the copyright holder.
 *
 */

/* $Id: xaux_ext_common.h,v 1.1.1.1 2002/04/06 02:23:31 famao Exp $ */

/* vi:set ts=4 sw=4: */


/*
Copyright 1985, 1986, 1987, 1991, 1998  The Open Group

Portions Copyright 2000 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/

/* $Id: xaux_ext_common.h,v 1.1.1.1 2002/04/06 02:23:31 famao Exp $ */
/* This file is modified by Motonobu Ichimura <famao@kondara.org> */

#ifndef	XAUX_EXT_COMMON_H
#define	XAUX_EXT_COMMON_H

typedef enum aux_ext_data_type_enum {
	AUX_EXT_DATA_NONE = 0,
	AUX_EXT_DATA_START = 1,
	AUX_EXT_DATA_DRAW = 2,
	AUX_EXT_DATA_DONE = 3,
	AUX_EXT_DATA_SETVALUE = 4
} aux_ext_data_type_t;

typedef struct aux_ext_string_struct {
	int		length;
	unsigned char *	ptr;
} aux_ext_string_t;

typedef struct aux_ext_data_struct {
	aux_ext_data_type_t	type;
	int		im;
	int		ic;
	int		aux_index;
	int		aux_name_length;
	unsigned char *	aux_name;
	int		integer_count;
	int *		integer_list;
	int		string_count;
	aux_ext_string_t *	string_list;
	unsigned char *	string_ptr;
	Window		clientwin;
	Window		focuswin;
	XPoint		point;
} aux_ext_data_t;

extern Bool xaux_ext_init_classes(Display  *, xaux_class_t *, Window);
extern Bool xaux_ext_process_client_message(Display *, XClientMessageEvent *);

extern xaux_class_t xaux_class;
extern Bool xaux_ext_Start(xaux_class_t *, aux_ext_data_t *);
extern Bool xaux_ext_Draw(xaux_class_t *, aux_ext_data_t *);
extern Bool xaux_ext_Done(xaux_class_t *, aux_ext_data_t *);

/* conversion utilities */
#if 0
extern size_t utf16_mb(const char **, size_t *, char **, size_t *);
extern size_t mb_utf16(const char **, size_t *, char **, size_t *);
#endif

Bool xaux_ext_SetValue (Display *display, xaux_class_t *xc, aux_ext_data_t *aux_ext_data);

#ifndef	linux
#include <Xm/Xm.h>
#endif

#ifdef USE_CDE_HELP
#include <unistd.h>
#include <signal.h>
extern void HelpInit(Widget, char *, int, char **);
extern void HelpInvoke(Widget, char *);
#else
extern void HelpInvoke(char *);
#endif

#define	DEFAULT_HELP_PATH "file:/usr/lib/im/locale/ja/sampleja3/help/"

#endif	/* !XAUX_EXT_COMMON_H */

